## libkolabxml 1.0.1

=== CMakeLists.txt ===
# The special language NONE is not available in cmake 2.6
if(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} GREATER 6)
    project(Libkolabxml NONE)
else()
    project(Libkolabxml C)
endif()

cmake_minimum_required(VERSION 2.6)

option( BUILD_TESTS "Build the tests" TRUE )
option( BUILD_UTILS "Build optional utils" FALSE )
option( DIST_ONLY "Build dist targets only (does not require a compiler)" FALSE )
option( PYTHON_BINDINGS "Build bindings for python" FALSE )
option( PHP_BINDINGS "Build bindings for php" FALSE )
option( CSHARP_BINDINGS "Build bindings for csharp" FALSE )
option( JAVA_BINDINGS "Build bindings for java" FALSE )


set(Libkolabxml_MODULE_DIR ${Libkolabxml_SOURCE_DIR}/cmake/modules)
set(CMAKE_MODULE_PATH ${Libkolabxml_MODULE_DIR})

# only available from cmake-2.8.0
if(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} GREATER 7)
    cmake_policy(SET CMP0012 NEW)
endif()

# only available from cmake-2.8.4
if(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} GREATER 7 AND
    ${CMAKE_PATCH_VERSION} GREATER 3)
    cmake_policy(SET CMP0017 NEW)
endif()

# Versioning
# x.y.z scheme
# Development versions are only x.y
#
# i.e.
# 0.1 (0.1 development version)
# 0.1.0 (first release)
# 0.1.1 (patch release for 0.1.0)
# 0.2 (0.2 development version)

set (Libkolabxml_VERSION_MAJOR 1)
set (Libkolabxml_VERSION_MINOR 0)
# Enable the full x.y.z version only for release versions
set (Libkolabxml_VERSION_PATCH 1)
set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}.${Libkolabxml_VERSION_PATCH}" )
#set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}" )

set (Libkolabxml_VERSION_STRING ${CMAKE_PROJECT_NAME}-${Libkolabxml_VERSION})
set (KOLAB_FORMAT_VERSION "3.1.0")

message("Building DIST targets (make dist, make snapshot)")
#make dist requires a tag with ${ARCHIVE_NAME} (e.g. libkolabxml-0.2.0)
set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${Libkolabxml_VERSION})
add_custom_target(dist
    COMMAND git archive --prefix=${ARCHIVE_NAME}/ ${ARCHIVE_NAME}
        | bzip2 > ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

#snapshot of current development version
set(SNAPSHOTARCHIVE_NAME "${CMAKE_PROJECT_NAME}-${Libkolabxml_VERSION}-HEAD")
add_custom_target(snapshot
    COMMAND git archive --prefix=${SNAPSHOTARCHIVE_NAME}/ HEAD
        | bzip2 > ${CMAKE_BINARY_DIR}/${SNAPSHOTARCHIVE_NAME}.tar.bz2
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
        
#It's possible to make dist targets only using:
#cmake -DDIST_ONLY=TRUE  ..
if (DIST_ONLY)
    message("Building DIST targets ONLY (cmake -DDIST_ONLY=FALSE  .. for full build)")
    return()
endif()

#C++ is required from here on
enable_language(CXX)

set(LIB_INSTALL_DIR lib CACHE STRING "The directories where to install libraries to")
set(INCLUDE_INSTALL_DIR include CACHE STRING "The directory where to install headers to")
set(INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR}/kolabxml)
set(CMAKECONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/cmake/Libkolabxml )

# Make relative paths absolute (needed later on)
foreach(p LIB INCLUDE CMAKECONFIG)
    set(var ${p}_INSTALL_DIR)
    if(NOT IS_ABSOLUTE "${${var}}")
        set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
    endif()
endforeach()

configure_file(libkolabxml-version.h.cmake "${CMAKE_BINARY_DIR}/libkolabxml-version.h" @ONLY)

set(Boost_USE_MULTITHREADED ON)
find_package(Boost REQUIRED COMPONENTS thread system)
if (Boost_FOUND)
    message("Found boost in ${Boost_INCLUDE_DIRS}")
endif (Boost_FOUND)

find_package(LibkolabxmlDependencies REQUIRED) # Must be after findboost

set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall" )

execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion
                OUTPUT_VARIABLE GCC_VERSION)
if (GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7)
    message(STATUS "GCC Version >= 4.7, applying unqualified lookup workaround")
    # gcc 4.7 no longer performs unqualified lookups by default, see: http://gcc.gnu.org/gcc-4.7/porting_to.html.
    # This workaround is added for xsd code, which fails otherwise to compile. -fpermissive turns the errors into warnings. 
    # It's only temporary, and should be removed once xsd is fixed.
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive" ) 
endif()

file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/bindings)

set( SCHEMA_DIR ${CMAKE_SOURCE_DIR}/schemas )

# Generate bindings
# WARNING: The inclusion order in SCHEMAS matters with xerces < 3.1.0. It seems without XMLUni::fgXercesHandleMultipleImports at least kolabformat-xcard.xsd MUST be before xCard.xsd,
# otherwise the compiled schema will simply lack the definitions of kolabformat-xcard.xsd (this affects xsdbin only).
set( SCHEMAS
    ${SCHEMA_DIR}/ical/kolabformat-xcal.xsd
    ${SCHEMA_DIR}/ical/iCalendar-params.xsd
    ${SCHEMA_DIR}/ical/iCalendar-props.xsd
    ${SCHEMA_DIR}/ical/iCalendar-valtypes.xsd
    ${SCHEMA_DIR}/kolabformat-xcard.xsd
    ${SCHEMA_DIR}/xCard.xsd
    ${SCHEMA_DIR}/kolabformat.xsd
)

set( SCHEMA_SOURCEFILES  
    ${CMAKE_BINARY_DIR}/bindings/kolabformat.cxx
    ${CMAKE_BINARY_DIR}/bindings/xCard.cxx
    ${CMAKE_BINARY_DIR}/bindings/kolabformat-xcal.cxx
    ${CMAKE_BINARY_DIR}/bindings/kolabformat-xcard.cxx
    ${CMAKE_BINARY_DIR}/bindings/iCalendar-params.cxx
    ${CMAKE_BINARY_DIR}/bindings/iCalendar-props.cxx
    ${CMAKE_BINARY_DIR}/bindings/iCalendar-valtypes.cxx
#     bindings/iCalendar-link-extension.cxx
#     bindings/iCalendar-bw-extensions.cxx
#     bindings/iCalendar-ms-extensions.cxx
)

#xsdcxx cxx-tree --generate-xml-schema --generate-serialization --custom-type date_time --hxx-epilogue '#include "bindings/customtypes/xml-schema-custom.hxx"' xml-schema.xsd
# --generate-inline --extern-xml-schema xml-schema.xsd
# --cxx-suffix .cpp --hxx-suffix .h   
add_custom_command(OUTPUT ${SCHEMA_SOURCEFILES}
    COMMAND ${XSDCXX} cxx-tree --generate-polymorphic --generate-serialization  --namespace-map http://kolab.org=KolabXSD --root-element icalendar --root-element vcards --root-element note --root-element configuration --root-element file --output-dir ${CMAKE_BINARY_DIR}/bindings ${SCHEMAS}
    COMMENT "Generating XSD bindings"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    DEPENDS ${SCHEMAS}
    VERBATIM
    )

# Compile xsdbin if not found
if (NOT XSDBIN_FOUND)
    add_executable(xsdbin compiled/xsdbin.cxx)
    target_link_libraries(xsdbin ${XERCES_C})
    set(XSDBIN ${CMAKE_BINARY_DIR}/xsdbin)
endif ()

# Compile Schemas
add_custom_command(OUTPUT kolabformat-xcal-schema.cxx
        COMMAND ${XSDBIN} --verbose --array-name iCalendar_schema --output-dir ${CMAKE_BINARY_DIR} ${SCHEMAS}
        COMMENT "Compiling Kolab XSD schema"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        DEPENDS ${SCHEMAS} ${XSDBIN}
        VERBATIM
    )

set( SCHEMA_SOURCEFILES ${SCHEMA_SOURCEFILES} ${CMAKE_BINARY_DIR}/kolabformat-xcal-schema.cxx)

# ---------

SET_SOURCE_FILES_PROPERTIES(${SCHEMA_SOURCEFILES} PROPERTIES GENERATED 1)
ADD_CUSTOM_TARGET(generate_bindings ALL DEPENDS ${SCHEMA_SOURCEFILES})

include_directories(
    ./
    compiled
    src/containers
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
    ${XSDCXX_INCLUDE_DIRS}
    ${XERCES_C_INCLUDE_DIRS}
    ${CURL_INCLUDE_DIRS}
)


add_subdirectory(src)

if (BUILD_UTILS)
    add_subdirectory(utils)
endif()

if (BUILD_TESTS)
    enable_testing()
    add_subdirectory(tests)
endif()

#Get the include directory relative to CMAKECONFIG_INSTALL_DIR
file(RELATIVE_PATH REL_INCLUDE_DIR "${CMAKECONFIG_INSTALL_DIR}" "${INCLUDE_INSTALL_DIR}")
#Assemble the full relative path. This will be used in the LibkolabxmlConfig.cmake, which will be installed in CMAKECONFIG_INSTALL_DIR
set(CONF_INCLUDE_DIRS "\${Libkolabxml_CMAKE_DIR}/${REL_INCLUDE_DIR}")

install(EXPORT LibkolabxmlExport DESTINATION ${CMAKECONFIG_INSTALL_DIR} FILE LibkolabxmlTargets.cmake )

configure_file(${Libkolabxml_MODULE_DIR}/LibkolabxmlConfig.cmake.in ${Libkolabxml_BINARY_DIR}/LibkolabxmlConfig.cmake @ONLY )
configure_file(${Libkolabxml_MODULE_DIR}/LibkolabxmlConfigVersion.cmake.in ${Libkolabxml_BINARY_DIR}/LibkolabxmlConfigVersion.cmake @ONLY )
# Install these two files into the same directory as the generated exports-file.
install(FILES ${Libkolabxml_BINARY_DIR}/LibkolabxmlConfig.cmake ${Libkolabxml_BINARY_DIR}/LibkolabxmlConfigVersion.cmake
        DESTINATION ${CMAKECONFIG_INSTALL_DIR} )

=== tests/CMakeLists.txt ===
find_package(Qt4)
add_definitions(-DTEST_DATA_PATH="${CMAKE_CURRENT_SOURCE_DIR}")

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/.. )
include_directories(${CMAKE_CURRENT_BINARY_DIR})

include_directories(${QT_INCLUDES} ${QT_INCLUDE_DIR} QtCore)
if (NOT APPLE)
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--no-undefined" ) 
endif()

if(PHP_BINDINGS)
    add_test(phptest php -d enable_dl=On -d include_path='.:/usr/share/pear:${CMAKE_BINARY_DIR}/src/php' -d extension=${CMAKE_BINARY_DIR}/src/php/kolabformat.so ${CMAKE_SOURCE_DIR}/src/php/test.php --verbose)
endif()

if (QT4_FOUND)
    message("Buildings tests")
    QT4_AUTOMOC(bindingstest.cpp)
    add_executable(bindingstest bindingstest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${BINDINGSTEST_MOC})
    target_link_libraries(bindingstest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
    add_test(bindingstest ${CMAKE_CURRENT_BINARY_DIR}/bindingstest)

    QT4_AUTOMOC(conversiontest.cpp)
    add_executable(conversiontest conversiontest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${CONVERSIONTEST_MOC})
    target_link_libraries(conversiontest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
    add_test(conversiontest ${CMAKE_CURRENT_BINARY_DIR}/conversiontest)

    QT4_AUTOMOC(parsingtest.cpp)
    add_executable(parsingtest parsingtest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${CONVERSIONTEST_MOC})
    target_link_libraries(parsingtest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
    add_test(parsingtest ${CMAKE_CURRENT_BINARY_DIR}/parsingtest)

    QT4_AUTOMOC(validationtest.cpp)
    add_executable(validationtest validationtest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${CONVERSIONTEST_MOC})
    target_link_libraries(validationtest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
    add_test(validationtest ${CMAKE_CURRENT_BINARY_DIR}/validationtest)
else()
    message(WARNING "Could not build tests because qt is missing")
endif()

=== src/csharp/CMakeLists.txt ===
# Generate C# wrapper
include_directories(../)

# Compile CSHARP Bindings
find_program(GMCS NAMES gmcs HINTS /usr/bin/)

if (NOT GMCS)
    message("gmcs not found, not building csharp bindings")
    return()
endif()

set(KOLAB_SWIG_CSHARP_SOURCE_FILE ${CMAKE_CURRENT_BINARY_DIR}/csharp_kolabformat_wrapper.cpp) #it seems we never use this file? it works at least as a dependecy.
set(KOLAB_SWIG_CSHARP_FILES
        ${CMAKE_CURRENT_BINARY_DIR}/Address.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Affiliation.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Alarm.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Attachment.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Attendee.cs
        ${CMAKE_CURRENT_BINARY_DIR}/CategoryColor.cs
        ${CMAKE_CURRENT_BINARY_DIR}/cDateTime.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Classification.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Configuration.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Contact.cs
        ${CMAKE_CURRENT_BINARY_DIR}/ContactReference.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Crypto.cs
        ${CMAKE_CURRENT_BINARY_DIR}/CustomProperty.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Cutype.cs
        ${CMAKE_CURRENT_BINARY_DIR}/DayPos.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Dictionary.cs
        ${CMAKE_CURRENT_BINARY_DIR}/DistList.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Duration.cs
        ${CMAKE_CURRENT_BINARY_DIR}/ErrorSeverity.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Email.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Event.cs
        ${CMAKE_CURRENT_BINARY_DIR}/File.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Geo.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Journal.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Key.cs
        ${CMAKE_CURRENT_BINARY_DIR}/kolabformatPINVOKE.cs
        ${CMAKE_CURRENT_BINARY_DIR}/NameComponents.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Note.cs
        ${CMAKE_CURRENT_BINARY_DIR}/PartStatus.cs
        ${CMAKE_CURRENT_BINARY_DIR}/RecurrenceRule.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Related.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Relative.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Role.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Status.cs
        ${CMAKE_CURRENT_BINARY_DIR}/SWIGTYPE_p_Kolab__Freebusy.cs
        ${CMAKE_CURRENT_BINARY_DIR}/SWIGTYPE_p_std__vectorT_Kolab__Todo_t.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Telephone.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Todo.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Url.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectoraddress.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectoraffiliation.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectoralarm.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectorattachment.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectorattendee.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectorcategorycolor.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectorcontactref.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectorcs.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectordatetime.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectordaypos.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectoremail.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectorevent.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectorgeo.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectori.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectorkey.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectorrelated.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectors.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectortelephone.cs
        ${CMAKE_CURRENT_BINARY_DIR}/vectorurl.cs
        ${CMAKE_CURRENT_BINARY_DIR}/Weekday.cs
    )
set(KOLAB_SWIG_CSHARP_DLL_FILE ${CMAKE_CURRENT_BINARY_DIR}/kolabformat.dll)
set(KOLAB_SWIG_CSHARP_TEST_FILE ${CMAKE_CURRENT_BINARY_DIR}/test.exe)

add_custom_command(OUTPUT ${KOLAB_SWIG_CSHARP_SOURCE_FILE} ${KOLAB_SWIG_CSHARP_FILES}
        COMMAND ${SWIG} -v -c++ -csharp -o ${KOLAB_SWIG_CSHARP_SOURCE_FILE}  ../kolabformat.i
        COMMENT "Generating C# bindings"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        DEPENDS ../kolabformat.i kolabxml
        VERBATIM
    )

SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_CSHARP_SOURCE_FILE} PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_CSHARP_FILES} PROPERTIES GENERATED 1)

configure_file(test.cs ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)

add_custom_command(OUTPUT ${KOLAB_SWIG_CSHARP_DLL_FILE}
        COMMAND ${GMCS} -target:library "${CMAKE_CURRENT_BINARY_DIR}/kolabformat.cs" ${KOLAB_SWIG_CSHARP_FILES}
        COMMENT "Compiling C# library"
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        DEPENDS kolabxml ${KOLAB_SWIG_CSHARP_SOURCE_FILE} ${KOLAB_SWIG_CSHARP_FILES}
        VERBATIM
    )

add_custom_command(OUTPUT ${KOLAB_SWIG_CSHARP_TEST_FILE}
        COMMAND ${GMCS} -reference:${KOLAB_SWIG_CSHARP_DLL_FILE} ${CMAKE_CURRENT_BINARY_DIR}/test.cs
        COMMENT "Compiling C# test.exe"
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        DEPENDS kolabxml ${KOLAB_SWIG_CSHARP_SOURCE_FILE} ${KOLAB_SWIG_CSHARP_DLL_FILE}
        VERBATIM
    )

SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_CSHARP_DLL_FILE} PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_CSHARP_TEST_FILE} PROPERTIES GENERATED 1)
ADD_CUSTOM_TARGET(generate_csharp_bindings ALL DEPENDS ${KOLAB_SWIG_CSHARP_DLL_FILE} ${KOLAB_SWIG_CSHARP_TEST_FILE})

set(CSHARP_INSTALL_DIR "${CMAKE_CURRENT_BINARY_DIR}/csharpbindings" CACHE STRING "Install directory for csharp bindings.")

#not sure about the LIBRARY here, but might work
install(FILES ${KOLAB_SWIG_CSHARP_DLL_FILE} DESTINATION ${CSHARP_INSTALL_DIR})
install(FILES ${KOLAB_SWIG_CSHARP_TEST_FILE} DESTINATION ${CSHARP_INSTALL_DIR})

=== src/java/CMakeLists.txt ===
# Generate Java wrapper
include_directories(../)

set(KOLAB_SWIG_JAVA_SOURCE_FILE java_kolabformat_wrapper.cpp)
set(KOLAB_SWIG_JAVA_FILES
        ${CMAKE_CURRENT_BINARY_DIR}/Address.java
        ${CMAKE_CURRENT_BINARY_DIR}/Affiliation.java
        ${CMAKE_CURRENT_BINARY_DIR}/Alarm.java
        ${CMAKE_CURRENT_BINARY_DIR}/Attachment.java
        ${CMAKE_CURRENT_BINARY_DIR}/Attendee.java
        ${CMAKE_CURRENT_BINARY_DIR}/CategoryColor.java
        ${CMAKE_CURRENT_BINARY_DIR}/cDateTime.java
        ${CMAKE_CURRENT_BINARY_DIR}/Classification.java
        ${CMAKE_CURRENT_BINARY_DIR}/Configuration.java
        ${CMAKE_CURRENT_BINARY_DIR}/Contact.java
        ${CMAKE_CURRENT_BINARY_DIR}/ContactReference.java
        ${CMAKE_CURRENT_BINARY_DIR}/Crypto.java
        ${CMAKE_CURRENT_BINARY_DIR}/CustomProperty.java
        ${CMAKE_CURRENT_BINARY_DIR}/Cutype.java
        ${CMAKE_CURRENT_BINARY_DIR}/DayPos.java
        ${CMAKE_CURRENT_BINARY_DIR}/Dictionary.java
        ${CMAKE_CURRENT_BINARY_DIR}/DistList.java
        ${CMAKE_CURRENT_BINARY_DIR}/Duration.java
        ${CMAKE_CURRENT_BINARY_DIR}/ErrorSeverity.java
        ${CMAKE_CURRENT_BINARY_DIR}/Event.java
        ${CMAKE_CURRENT_BINARY_DIR}/Geo.java
        ${CMAKE_CURRENT_BINARY_DIR}/Journal.java
        ${CMAKE_CURRENT_BINARY_DIR}/Key.java
        ${CMAKE_CURRENT_BINARY_DIR}/kolabformat.java
        ${CMAKE_CURRENT_BINARY_DIR}/kolabformatJNI.java
        ${CMAKE_CURRENT_BINARY_DIR}/Makefile
        ${CMAKE_CURRENT_BINARY_DIR}/NameComponents.java
        ${CMAKE_CURRENT_BINARY_DIR}/Note.java
        ${CMAKE_CURRENT_BINARY_DIR}/PartStatus.java
        ${CMAKE_CURRENT_BINARY_DIR}/RecurrenceRule.java
        ${CMAKE_CURRENT_BINARY_DIR}/Related.java
        ${CMAKE_CURRENT_BINARY_DIR}/Relative.java
        ${CMAKE_CURRENT_BINARY_DIR}/Role.java
        ${CMAKE_CURRENT_BINARY_DIR}/Status.java
        ${CMAKE_CURRENT_BINARY_DIR}/SWIGTYPE_p_Kolab__Freebusy.java
        ${CMAKE_CURRENT_BINARY_DIR}/Telephone.java
        ${CMAKE_CURRENT_BINARY_DIR}/Todo.java
        ${CMAKE_CURRENT_BINARY_DIR}/Url.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectoraddress.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectoraffiliation.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectoralarm.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectorattachment.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectorattendee.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectorcategorycolor.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectorcontactref.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectorcs.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectordatetime.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectordaypos.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectorgeo.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectori.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectorkey.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectorrelated.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectors.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectortelephone.java
        ${CMAKE_CURRENT_BINARY_DIR}/vectorurl.java
        ${CMAKE_CURRENT_BINARY_DIR}/Weekday.java
    )

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${KOLAB_SWIG_JAVA_SOURCE_FILE} ${KOLAB_SWIG_JAVA_FILES}
    COMMAND ${SWIG} -v -c++ -java -o ${CMAKE_CURRENT_BINARY_DIR}/${KOLAB_SWIG_JAVA_SOURCE_FILE}  ../kolabformat.i
    COMMENT "Generating Java bindings"
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ../kolabformat.i kolabxml
    VERBATIM
    )

SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_JAVA_SOURCE_FILE} PROPERTIES GENERATED 1)

ADD_CUSTOM_TARGET(generate_JAVA_bindings ALL DEPENDS ${KOLAB_SWIG_JAVA_SOURCE_FILE})

# Compile JAVA Bindings

set(JAVA_INSTALL_DIR "${CMAKE_CURRENT_BINARY_DIR}/javabindings" CACHE STRING "Install directory for java bindings.")

install( FILES
        ${KOLAB_SWIG_JAVA_FILES}
        DESTINATION ${JAVA_INSTALL_DIR}
    )

=== debian/changelog ===
libkolabxml (1.0.1-0ubuntu3) trusty; urgency=medium

  * No change rebuild for phpapi-20121212+lfs (LFS ABI break on 32-bit
    arches).

 -- Robie Basak <robie.basak@ubuntu.com>  Wed, 19 Feb 2014 08:21:03 +0000

libkolabxml (1.0.1-0ubuntu2) trusty; urgency=low

  * Remove dh_makeshlibs, not required with abi bump
  * Fix lintian overrides to use new package name

 -- Rohan Garg <rohangarg@kubuntu.org>  Wed, 11 Dec 2013 12:41:19 +0100

libkolabxml (1.0.1-0ubuntu1) trusty; urgency=low

  * New upstream release
  * Add php5-cli to Build-Depends for running tests
  * libkolabxml0 is now libkolabxml1
  * Update install files
  * Drop xcardconversions-spelling-error.patch, applied upstream

 -- Rohan Garg <rohangarg@kubuntu.org>  Tue, 10 Dec 2013 15:54:56 +0100

libkolabxml (0.8.4-5build1) trusty; urgency=low

  * No change rebuild against Boost 1.54.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Sun, 27 Oct 2013 00:39:49 +0100

=== debian/control ===
Source: libkolabxml
Section: libs
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Kolab Maintainers <pkg-kolab-devel@lists.alioth.debian.org>
Uploaders: Jeroen van Meeuwen (Kolab Systems) <vanmeeuwen@kolabsys.com>, Paul Klos <kolab@klos2day.nl>
Build-Depends: cmake,
               debhelper (>= 9),
               libxerces-c-dev,
               xsdcxx,
               uuid-dev,
               libboost-dev,
               libboost-system-dev,
               libboost-thread-dev,
               swig,
               libcurl4-gnutls-dev,
               php5-dev,
               python-dev (>= 2.7),
               php5-cli
X-Python-Version: >= 2.7
Standards-Version: 3.9.4
Homepage: http://git.kolab.org/libkolabxml

Package: libkolabxml1
Architecture: any
Depends: ${misc:Depends},
	${shlibs:Depends}
Description: Kolab XML format (shared library)
 Libkolabxml is the reference implementation of the Kolab XML format.
 .
 The Kolab 3.0 XML format is defined in
 <http://wiki.kolab.org/User:Mollekopf/Drafts/KEP:17>.
 .
 This package provides serialization/deserialization from/to  in-memory
 representations for all Kolab Objects, including input validation.

Package: php-kolabformat
Architecture: any
Depends: libkolabxml1 (= ${binary:Version}),
	${misc:Depends},
	${shlibs:Depends},
	${php:Depends},
    ucf
Description: PHP bindings for Kolab Format 3.0 XML parsing
 Libkolabxml is the reference implementation of the Kolab XML format
 For more information see the libkolabxml package.
 .
 This package provides PHP bindings for libkolabxml.

Package: python-kolabformat
Architecture: any
Section: python
Depends: libkolabxml1 (= ${binary:Version}),
	python,
	${misc:Depends},
	${shlibs:Depends}
Description: Python bindings for Kolab Format 3.0 XML parsing
 Libkolabxml is the reference implementation of the Kolab XML format.
 For more information see the libkolabxml package.
 .
 This package provides Python bindings for libkolabxml.

Package: libkolabxml-dev
Section: libdevel
Architecture: any
Depends: libkolabxml1 (= ${binary:Version}),
         ${misc:Depends}, libboost-dev
Description: Development files for libkolabxml
 Libkolabxml is the reference implementation of the Kolab XML format.
 For more information see the libkolabxml package.
 .
 This package provides development files libkolabxml.

=== debian/rules ===
#!/usr/bin/make -f

PHPAPI := $(shell php-config --phpapi)
PYTHON_SITEARCH := $(shell python -c 'from distutils.sysconfig import get_python_lib; print get_python_lib(1)')

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND="-Wl,--as-needed"

%:
	dh $@ --parallel --with python2

override_dh_gencontrol:
	echo "php:Depends=phpapi-${PHPAPI}" >> debian/php-kolabformat.substvars
	dh_gencontrol

override_dh_auto_configure:
	dh_auto_configure -- \
		-DPHP_BINDINGS=ON \
		-DPYTHON_BINDINGS=ON \
		-DPYTHON_INSTALL_DIR=$(PYTHON_SITEARCH)

override_dh_install:
	dh_install --fail-missing

=== debian/watch ===
version=3
http://git.kolab.org/libkolabxml/ \
  /libkolabxml/snapshot/libkolabxml-([0-9\.]+)\.tar\.gz

## libkolabxml 1.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,7 +43,7 @@
 set (Libkolabxml_VERSION_MAJOR 1)
 set (Libkolabxml_VERSION_MINOR 0)
 # Enable the full x.y.z version only for release versions
-set (Libkolabxml_VERSION_PATCH 1)
+set (Libkolabxml_VERSION_PATCH 2)
 set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}.${Libkolabxml_VERSION_PATCH}" )
 #set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}" )
 
@@ -75,7 +75,7 @@
 #C++ is required from here on
 enable_language(CXX)
 
-set(LIB_INSTALL_DIR lib CACHE STRING "The directories where to install libraries to")
+set(LIB_INSTALL_DIR lib${LIB_SUFFIX} CACHE STRING "The directories where to install libraries to")
 set(INCLUDE_INSTALL_DIR include CACHE STRING "The directory where to install headers to")
 set(INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR}/kolabxml)
 set(CMAKECONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/cmake/Libkolabxml )

=== src/csharp/CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,11 @@
         ${CMAKE_CURRENT_BINARY_DIR}/Related.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Relative.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Role.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Snippet.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/SnippetsCollection.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Status.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Snippet.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/SnippetsCollection.cs
         ${CMAKE_CURRENT_BINARY_DIR}/SWIGTYPE_p_Kolab__Freebusy.cs
         ${CMAKE_CURRENT_BINARY_DIR}/SWIGTYPE_p_std__vectorT_Kolab__Todo_t.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Telephone.cs
@@ -67,6 +71,7 @@
         ${CMAKE_CURRENT_BINARY_DIR}/vectorkey.cs
         ${CMAKE_CURRENT_BINARY_DIR}/vectorrelated.cs
         ${CMAKE_CURRENT_BINARY_DIR}/vectors.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectorsnippet.cs
         ${CMAKE_CURRENT_BINARY_DIR}/vectortelephone.cs
         ${CMAKE_CURRENT_BINARY_DIR}/vectorurl.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Weekday.cs

=== src/java/CMakeLists.txt ===
--- 
+++ 
@@ -37,6 +37,8 @@
         ${CMAKE_CURRENT_BINARY_DIR}/Relative.java
         ${CMAKE_CURRENT_BINARY_DIR}/Role.java
         ${CMAKE_CURRENT_BINARY_DIR}/Status.java
+        ${CMAKE_CURRENT_BINARY_DIR}/Snippet.java
+        ${CMAKE_CURRENT_BINARY_DIR}/SnippetsCollection.java
         ${CMAKE_CURRENT_BINARY_DIR}/SWIGTYPE_p_Kolab__Freebusy.java
         ${CMAKE_CURRENT_BINARY_DIR}/Telephone.java
         ${CMAKE_CURRENT_BINARY_DIR}/Todo.java
@@ -56,6 +58,7 @@
         ${CMAKE_CURRENT_BINARY_DIR}/vectorkey.java
         ${CMAKE_CURRENT_BINARY_DIR}/vectorrelated.java
         ${CMAKE_CURRENT_BINARY_DIR}/vectors.java
+        ${CMAKE_CURRENT_BINARY_DIR}/vectorsnippet.java
         ${CMAKE_CURRENT_BINARY_DIR}/vectortelephone.java
         ${CMAKE_CURRENT_BINARY_DIR}/vectorurl.java
         ${CMAKE_CURRENT_BINARY_DIR}/Weekday.java

=== debian/changelog ===
libkolabxml (1.0.2-2build1) vivid; urgency=medium

  * No change rebuild against PHP 5.6 (phpapi-20131226).

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 27 Jan 2015 15:55:14 +0000

libkolabxml (1.0.2-2) unstable; urgency=medium

  * Fix symbols file. Part of it was accidentally deleted.

 -- Diane Trout <diane@ghic.org>  Sun, 28 Sep 2014 21:40:40 -0700

libkolabxml (1.0.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Remove patch applied upstream: xsdcxx-4.0-support.patch
  * Update symbols file.

 -- Maximiliano Curia <maxy@debian.org>  Thu, 04 Sep 2014 13:27:54 +0200

libkolabxml (1.0.1-4) unstable; urgency=medium

  * Team upload.

  * Update symbols files. (Closes: #755562).

 -- Maximiliano Curia <maxy@debian.org>  Mon, 25 Aug 2014 20:07:26 +0200

libkolabxml (1.0.1-3) unstable; urgency=medium

  * Team upload.

  [ Diane Trout ]
  * Add xsdcxx-4.0-support.patch (Closes: #756866)
  * Update libkolabxml1.symbols
    - many symbols changed due to change in simple_type template
    - needed to tag many symbols that used auto_ptr template
      as (optional=templinst)
    - The components2 namespace was not generated by xsdcxx.
    - A few symbols associated with valarm moved from components1
      to components namespace.

 -- Maximiliano Curia <maxy@debian.org>  Mon, 18 Aug 2014 15:27:40 +0200

libkolabxml (1.0.1-2) unstable; urgency=medium

  * Team upload.
  * Update symbols files. (Closes: #755562)

 -- Maximiliano Curia <maxy@debian.org>  Tue, 22 Jul 2014 11:51:49 +0200

libkolabxml (1.0.1-1) unstable; urgency=medium

  * Team upload.

  [ Paul Klos ]
  * Imported Upstream version 1.0.1 (Closes: #730600)

  [ Diane Trout ]
  * Add libkolabxml1.symbols.
  * Remove no-symbols-control-file from lintian overrides.
  * Add libcurl4-gnutls-dev to libkolabxml-dev dependencies.
    Without that building kdepim-runtime didn't know it needed curl.
  * Add myself to uploaders.
  * Update Standards-Version to 3.9.5. No changes needed.
  * Update Vcs-Git to canonical URL.
  * Force specific python versions for SWIG, avoids linking against
    python 3 if its available.

 -- Diane Trout <diane@ghic.org>  Sat, 28 Jun 2014 20:31:35 -0700

=== debian/rules ===
#!/usr/bin/make -f

PHPAPI := $(shell php-config --phpapi)
PYTHON := $(shell pyversions -d)
PYTHON_SITEARCH := $(shell python -c 'from distutils.sysconfig import get_python_lib; print get_python_lib(1)')

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND="-Wl,--as-needed"

%:
	dh $@ --parallel --with python2,pkgkde_symbolshelper

override_dh_gencontrol:
	echo "php:Depends=phpapi-${PHPAPI}" >> debian/php-kolabformat.substvars
	dh_gencontrol

override_dh_auto_configure:
	dh_auto_configure -- \
		-DPHP_BINDINGS=ON \
		-DPYTHON_BINDINGS=ON \
		-DPYTHON_INSTALL_DIR=$(PYTHON_SITEARCH) \
		-DPYTHON_INCLUDE_DIR=/usr/include/$(PYTHON) \
		-DPYTHON_LIBRARY=/usr/lib/$(DEB_BUILD_MULTIARCH)/lib$(PYTHON).so

override_dh_install:
	mkdir -p debian/tmp/usr/share/php
	mv debian/tmp/usr/lib/php5/$(PHPAPI)/kolabformat.php debian/tmp/usr/share/php/kolabformat.php
	dh_install --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -V 'libkolabxml1 (>= 1.0.1)'

## libkolabxml 1.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,8 @@
 option( PHP_BINDINGS "Build bindings for php" FALSE )
 option( CSHARP_BINDINGS "Build bindings for csharp" FALSE )
 option( JAVA_BINDINGS "Build bindings for java" FALSE )
+option( QT5_BUILD "Build libkolabxml using the Qt5 framework" FALSE)
+
 
 
 set(Libkolabxml_MODULE_DIR ${Libkolabxml_SOURCE_DIR}/cmake/modules)
@@ -41,9 +43,9 @@
 # 0.2 (0.2 development version)
 
 set (Libkolabxml_VERSION_MAJOR 1)
-set (Libkolabxml_VERSION_MINOR 0)
+set (Libkolabxml_VERSION_MINOR 1)
 # Enable the full x.y.z version only for release versions
-set (Libkolabxml_VERSION_PATCH 2)
+set (Libkolabxml_VERSION_PATCH 1)
 set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}.${Libkolabxml_VERSION_PATCH}" )
 #set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}" )

=== tests/CMakeLists.txt ===

#### Qt 4 and 5 ####
if(QT5_BUILD)
  find_package(ECM 1.1.0 REQUIRED NO_MODULE)
  set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

  find_package(Qt5Core REQUIRED)
  find_package(Qt5Test REQUIRED)

  include("../cmake/modules/ECMQt4To5Porting.cmake")
  include_directories(${QT_INCLUDES}) # TODO: Port away from this.

  if(CMAKE_VERSION VERSION_LESS 2.8.9)
    message(FATAL_ERROR "Akonadi Qt 5 build requires at least CMake version 2.8.9")
  endif()

  if (Qt5_POSITION_INDEPENDENT_CODE)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  endif()

  set(QT_QTTEST_LIBRARIES Qt5::Test)
else()
  set(QT_USE_IMPORTED_TARGETS TRUE) # Qt 4 only
  set(QT_MIN_VERSION 4.6.2)         # Qt 4 only

  find_package(Qt4 REQUIRED)
endif()


add_definitions(-DTEST_DATA_PATH="${CMAKE_CURRENT_SOURCE_DIR}")

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/.. )
include_directories(${CMAKE_CURRENT_BINARY_DIR})

include_directories(${QT_INCLUDES} ${QT_INCLUDE_DIR} QtCore)
if (NOT APPLE)
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--no-undefined" ) 
endif()

if(PHP_BINDINGS)
    add_test(phptest php -d enable_dl=On -d include_path='.:/usr/share/pear:${CMAKE_BINARY_DIR}/src/php' -d extension=${CMAKE_BINARY_DIR}/src/php/kolabformat.so ${CMAKE_SOURCE_DIR}/src/php/test.php --verbose)
endif()

if (QT4_FOUND OR Qt5Core_FOUND)
    if (Qt5Core_FOUND)
      set(CMAKE_AUTOMOC ON)
      set(CMAKE_INCLUDE_CURRENT_DIR ON)
    endif()

    message("Buildings tests")
    if (QT4_FOUND)
      QT4_AUTOMOC(bindingstest.cpp)
      QT4_AUTOMOC(conversiontest.cpp)
      QT4_AUTOMOC(parsingtest.cpp)
      QT4_AUTOMOC(validationtest.cpp)
      QT4_AUTOMOC(kolabconversationtest.cpp)
     endif()

    add_executable(bindingstest bindingstest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${BINDINGSTEST_MOC})
    target_link_libraries(bindingstest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
    add_test(bindingstest ${CMAKE_CURRENT_BINARY_DIR}/bindingstest)

    add_executable(conversiontest conversiontest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${CONVERSIONTEST_MOC})
    target_link_libraries(conversiontest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
    add_test(conversiontest ${CMAKE_CURRENT_BINARY_DIR}/conversiontest)

    add_executable(parsingtest parsingtest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${PARSINGTEST_MOC})
    target_link_libraries(parsingtest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
    add_test(parsingtest ${CMAKE_CURRENT_BINARY_DIR}/parsingtest)

    add_executable(validationtest validationtest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${VALIDATIONTEST_MOC})
    target_link_libraries(validationtest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
    add_test(validationtest ${CMAKE_CURRENT_BINARY_DIR}/validationtest)

    add_executable(kolabconversationtest kolabconversationtest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${KOLABCONVERSATIONTEST_MOC})
    target_link_libraries(kolabconversationtest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
    add_test(kolabconversationtest ${CMAKE_CURRENT_BINARY_DIR}/kolabconversationtest)
else()
    message(WARNING "Could not build tests because qt is missing")
endif()

=== debian/changelog ===
libkolabxml (1.1.1-3) unstable; urgency=medium

  * Update symbols file for other architectures.

 -- Diane Trout <diane@debian.org>  Wed, 19 Aug 2015 15:55:43 -0700

libkolabxml (1.1.1-2) unstable; urgency=medium

  * Add breaks/replaces on pre-gcc5 library name.
  * Remove override_dh_makeshlibs, it was a relic
    from before libkolabxml was using pkgkde_symbolshelper.

 -- Diane Trout <diane@debian.org>  Tue, 18 Aug 2015 15:19:13 -0700

libkolabxml (1.1.1-1) unstable; urgency=medium

  * Update Diane Trout's email address
  * Rename libkolabxml1 to libkolabxml1v5 and create a new symbols
    file as many symbols changed because of the transition to gcc-5
  * New upstream release

 -- Diane Trout <diane@debian.org>  Tue, 18 Aug 2015 12:09:57 -0700

libkolabxml (1.1.0-3) unstable; urgency=medium

  * Team upload.
  * Update symbols files to build on all plattforms.

 -- Sandro Knauß <bugs@sandroknauss.de>  Sun, 31 May 2015 22:49:24 +0200

libkolabxml (1.1.0-2) unstable; urgency=medium

  * Get libkolabxml into unstable. It was uploaded to expermental because of
    the freeze.

 -- Sandro Knauß <bugs@sandroknauss.de>  Wed, 27 May 2015 17:59:20 +0200

libkolabxml (1.1.0-1) experimental; urgency=medium

  [ Sandro Knauß ]
  * Team upload.
  * New upstream release.
  * Added myself to uploaders with Diane's permission.
  * Added dh-python as BuildDep.
    - A warning in build process suggested this
  * Updated libkolabxml1.symbols (two missing symbols, no SONAME bumping).
    - one missing symbol:
    KolabObjects::getConfiguratinoType(Configuration::ConfigurationType)
    only a typo, till now only libkolab is dependend on libkolabxml and
    libkolab does not use this symbol. So the missing symbol can be seen
    as an internal one at the moment.
    - the other one uses auto_ptr, all auto_ptr symbols are internal ones.
  * Updated and reorderd copyright file.
  * Updated libkolabxml1.lintian-overrides to new soname.
  * Switched downloadurl to http://mirror.kolabsys.com/pub/releases/
    (there are also signed packages available, but unfortunately not
    detached)

  [ Diane Trout ]
  * Update symbols file with other architecture build logs.
    This should fix (Closes: #761934)
  * Update Standards-Version to 3.9.6. No changes needed.

 -- Sandro Knauß <bugs@sandroknauss.de>  Mon, 09 Mar 2015 17:42:42 +0100

=== debian/control ===
Source: libkolabxml
Section: libs
Priority: optional
Maintainer: Debian Kolab Maintainers <pkg-kolab-devel@lists.alioth.debian.org>
Uploaders: Paul Klos <kolab@klos2day.nl>, Diane Trout <diane@debian.org>, Sandro Knauß <bugs@sandroknauss.de>
Build-Depends: cmake,
               debhelper (>= 9),
               dh-python,
               pkg-kde-tools (>= 0.12),
               libxerces-c-dev,
               xsdcxx (>= 4.0),
               uuid-dev,
               libboost-dev,
               libboost-system-dev,
               libboost-thread-dev,
               swig,
               libcurl4-gnutls-dev,
               php5-dev,
               php5-cli,
               python-dev (>= 2.7),
               libqt4-dev
X-Python-Version: >= 2.7
Standards-Version: 3.9.6
Homepage: http://git.kolab.org/libkolabxml
Vcs-Git: git://anonscm.debian.org/pkg-kolab/libkolabxml.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-kolab/libkolabxml.git

Package: libkolabxml1v5
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libkolabxml1
Replaces: libkolabxml1
Description: Kolab XML format (shared library)
 Libkolabxml is the reference implementation of the Kolab XML format.
 .
 The Kolab 3.0 XML format is defined in
 <http://wiki.kolab.org/User:Mollekopf/Drafts/KEP:17>.
 .
 This package provides serialization/deserialization from/to  in-memory
 representations for all Kolab Objects, including input validation.

Package: php-kolabformat
Architecture: any
Depends: libkolabxml1v5 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ${php:Depends},
         ucf
Description: PHP bindings for Kolab Format 3.0 XML parsing
 Libkolabxml is the reference implementation of the Kolab XML format
 For more information see the libkolabxml package.
 .
 This package provides PHP bindings for libkolabxml.

Package: python-kolabformat
Architecture: any
Section: python
Depends: libkolabxml1v5 (= ${binary:Version}),
         python,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Python bindings for Kolab Format 3.0 XML parsing
 Libkolabxml is the reference implementation of the Kolab XML format.
 For more information see the libkolabxml package.
 .
 This package provides Python bindings for libkolabxml.

Package: libkolabxml-dev
Section: libdevel
Architecture: any
Depends: libkolabxml1v5 (= ${binary:Version}),
         ${misc:Depends}, libboost-dev, libboost-thread-dev, libxerces-c-dev,
         libcurl4-gnutls-dev
Description: Development files for libkolabxml
 Libkolabxml is the reference implementation of the Kolab XML format.
 For more information see the libkolabxml package.
 .
 This package provides development files libkolabxml.

=== debian/rules ===
--- 
+++ 
@@ -28,6 +28,3 @@
 	mkdir -p debian/tmp/usr/share/php
 	mv debian/tmp/usr/lib/php5/$(PHPAPI)/kolabformat.php debian/tmp/usr/share/php/kolabformat.php
 	dh_install --fail-missing
-
-override_dh_makeshlibs:
-	dh_makeshlibs -V 'libkolabxml1 (>= 1.0.1)'

## libkolabxml 1.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,7 +45,7 @@
 set (Libkolabxml_VERSION_MAJOR 1)
 set (Libkolabxml_VERSION_MINOR 1)
 # Enable the full x.y.z version only for release versions
-set (Libkolabxml_VERSION_PATCH 1)
+set (Libkolabxml_VERSION_PATCH 2)
 set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}.${Libkolabxml_VERSION_PATCH}" )
 #set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}" )

=== src/php/CMakeLists.txt ===
#Generate PHP wrapper
include_directories(../)

set(KOLAB_SWIG_PHP_SOURCE_FILE php_kolabformat_wrapper.cpp)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${KOLAB_SWIG_PHP_SOURCE_FILE} ${CMAKE_CURRENT_BINARY_DIR}/kolabformat.php
        COMMAND ${SWIG} -v -c++ -php -o ${CMAKE_CURRENT_BINARY_DIR}/${KOLAB_SWIG_PHP_SOURCE_FILE}  ../kolabformat.i
        COMMENT "Generating php bindings"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        DEPENDS ../kolabformat.i kolabxml
        VERBATIM
    )

set_source_files_properties(${KOLAB_SWIG_PHP_SOURCE_FILE} PROPERTIES GENERATED 1)
add_custom_target(generate_php_bindings ALL DEPENDS ${KOLAB_SWIG_PHP_SOURCE_FILE})


#Compile PHP Bindings
# Since there is no php library we can't compile with -Wl,--no-undefined
if (APPLE)
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flat_namespace -undefined suppress" )
endif()
set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable -Wno-unused-label -Wno-maybe-uninitialized -Wno-unused-function" )

# Try to find PHP5
find_path(PHP_INCLUDE_DIR NAMES main/php.h PATH_SUFFIXES php php5)
find_program(PHP_EXECUTABLE NAMES php)

# Libkolabxml needs PHP >= 5.3
set(PHP_MIN_VERSION 50300)

# Find where to install the extension files if it's not defined
if(NOT DEFINED PHP_INSTALL_DIR)
  find_program(PHP_CONFIG_EXECUTABLE NAMES php-config)
  if(PHP_CONFIG_EXECUTABLE)
    execute_process(COMMAND ${PHP_CONFIG_EXECUTABLE} --extension-dir
                    OUTPUT_VARIABLE _php_extensions_dir
    )
    string(REGEX REPLACE "\n" "" _php_extensions_dir "${_php_extensions_dir}")
    set(PHP_INSTALL_DIR ${_php_extensions_dir} CACHE STRING "Install directory for PHP bindings.")
  else()
    set(PHP_INSTALL_DIR ${LIB_INSTALL_DIR}/extensions)
  endif()
endif()

if(PHP_INCLUDE_DIR AND PHP_EXECUTABLE)
  file(READ ${PHP_INCLUDE_DIR}/main/php_version.h PHP_VERSION_CONTENT)
  string(REGEX MATCH "#define PHP_VERSION_ID[ ]*[0-9]*\n" _PHP_VERSION_ID_MATCH ${PHP_VERSION_CONTENT})
  if(_PHP_VERSION_ID_MATCH)
    string(REGEX REPLACE "#define PHP_VERSION_ID[ ]*([0-9]*)\n" "\\1" PHP_VERSION_ID ${_PHP_VERSION_ID_MATCH})
  endif()

  # Include the needed PHP5 subdirs
  set(PHP_INCLUDE_DIRS ${PHP_INCLUDE_DIR} ${PHP_INCLUDE_DIR}/main ${PHP_INCLUDE_DIR}/TSRM ${PHP_INCLUDE_DIR}/Zend )
endif()

if(NOT PHP_VERSION_ID VERSION_LESS ${PHP_MIN_VERSION})
  include_directories(${PHP_INCLUDE_DIRS})
  add_library(phpbindings SHARED ${KOLAB_SWIG_PHP_SOURCE_FILE})
  target_link_libraries(phpbindings kolabxml)
  set_target_properties(phpbindings PROPERTIES OUTPUT_NAME "kolabformat")
  set_target_properties(phpbindings PROPERTIES PREFIX "")

  configure_file(test.php ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)

  install(TARGETS phpbindings LIBRARY DESTINATION ${PHP_INSTALL_DIR})

  install( FILES
          ${CMAKE_CURRENT_BINARY_DIR}/kolabformat.php
          DESTINATION ${PHP_INSTALL_DIR}
      )

else()
  message(WARNING "not building php bindings because php was not found")
endif()

=== debian/changelog ===
libkolabxml (1.1.2-0ubuntu3) xenial; urgency=medium

  * Disable php-kolabformat while swig does not support PHP7.0 (LP: #1546823).
    - http://lists.kolab.org/pipermail/users/2015-December/020357.html

 -- Nishanth Aravamudan <nish.aravamudan@canonical.com>  Tue, 05 Apr 2016 10:02:53 -0700

libkolabxml (1.1.2-0ubuntu2) xenial; urgency=medium

  * Update symbols for all architectures 

 -- Philip Muškovac <yofel@kubuntu.org>  Wed, 09 Mar 2016 12:21:41 +0100

libkolabxml (1.1.2-0ubuntu1) xenial; urgency=medium

  * Debian merge: no remaining changes.
  * New upstream bugfix release. 
  * Update source. 
  * refresh symbols. 
  * refresh amd64 symbols. 

 -- Scarlett Clark <sgclark@kubuntu.org>  Fri, 04 Mar 2016 10:56:43 -0800

libkolabxml (1.1.1-2) UNRELEASED; urgency=medium

  * Add breaks/replaces on pre-gcc5 library name.

 -- Diane Trout <diane@debian.org>  Tue, 18 Aug 2015 14:52:14 -0700

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: libkolabxml
 Section: libs
 Priority: optional
-Maintainer: Debian Kolab Maintainers <pkg-kolab-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Kolab Maintainers <pkg-kolab-devel@lists.alioth.debian.org>
 Uploaders: Paul Klos <kolab@klos2day.nl>, Diane Trout <diane@debian.org>, Sandro Knauß <bugs@sandroknauss.de>
 Build-Depends: cmake,
                debhelper (>= 9),
@@ -15,8 +16,6 @@
                libboost-thread-dev,
                swig,
                libcurl4-gnutls-dev,
-               php5-dev,
-               php5-cli,
                python-dev (>= 2.7),
                libqt4-dev
 X-Python-Version: >= 2.7
@@ -39,19 +38,6 @@
  .
  This package provides serialization/deserialization from/to  in-memory
  representations for all Kolab Objects, including input validation.
-
-Package: php-kolabformat
-Architecture: any
-Depends: libkolabxml1v5 (= ${binary:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends},
-         ${php:Depends},
-         ucf
-Description: PHP bindings for Kolab Format 3.0 XML parsing
- Libkolabxml is the reference implementation of the Kolab XML format
- For more information see the libkolabxml package.
- .
- This package provides PHP bindings for libkolabxml.
 
 Package: python-kolabformat
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

PYTHON := $(shell pyversions -d)
PYTHON_SITEARCH := $(shell python -c 'from distutils.sysconfig import get_python_lib; print get_python_lib(1)')

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND="-Wl,--as-needed"

%:
	dh $@ --parallel --with python2,pkgkde_symbolshelper

override_dh_gencontrol:
	dh_gencontrol

override_dh_auto_configure:
	dh_auto_configure -- \
		-DPHP_BINDINGS=OFF \
		-DPYTHON_BINDINGS=ON \
		-DPYTHON_INSTALL_DIR=$(PYTHON_SITEARCH) \
		-DPYTHON_INCLUDE_DIR=/usr/include/$(PYTHON) \
		-DPYTHON_LIBRARY=/usr/lib/$(DEB_BUILD_MULTIARCH)/lib$(PYTHON).so

override_dh_install:
	dh_install --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -V 'libkolabxml1 (>= 1.0.1)'

=== debian/watch ===
version=3
http://mirror.kolabsys.com/pub/releases/libkolabxml-([0-9\.]+)\.tar\.gz
